
#include "main.h"
#include "args.h"
#include "memreader.h"

int			n_argtypes = 0;
argtype_t	argtypes[255];

argtype_t* get_argtype(string name)
{
	for (int a = 0; a < n_argtypes; a++)
	{
		if (argtypes[a].name == name)
			return &argtypes[a];
	}

	return NULL;
}

void parse_argtype(MemReader *mr)
{
	argtype_t *type = &argtypes[n_argtypes];
	n_argtypes++;

	type->name = mr->get_token();

	mr->check_token("{");
	string token = mr->get_token();

	while (token != "}")
	{
		if (token == "value")
		{
			short val = mr->get_integer();
			string name = mr->get_token();
			type->add_value(name, val, false);
		}

		if (token == "flag")
		{
			short val = mr->get_integer();
			string name = mr->get_token();
			type->add_value(name, val, true);
		}

		token = mr->get_token();
	}
}
