
struct col_config_t
{
	rgba_t			*colours;
	stringlist_t	names;
	string			name;

	col_config_t() { colours = NULL; }

	void add(string name, rgba_t col)
	{
		names.add(name);
		colours = (rgba_t *)realloc(colours, names.n_strings * sizeof(rgba_t));
		colours[names.n_strings - 1].set(col);
	}

	rgba_t* get_colour(string name)
	{
		for (DWORD c = 0; c < names.n_strings; c++)
		{
			if (*names.strings[c] == name)
				return &colours[c];
		}

		return NULL;
	}
};

#define SETCOL(name) set_colour(&col_##name, #name, config)

bool load_colour_configs(string filename);
void set_colour_config(string name);
